const { ccclass, property } = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';

    @property(cc.Prefab)
    cocosPrefab: cc.Prefab = null;

    @property(cc.Prefab)
    labelPrefab: cc.Prefab = null;

    start() {
        // init logic
        this.label.string = this.text;
    }

    onCreateCocos() {
        let startTime = new Date().getTime();
        cc.log('开始时间：' + startTime);
        for (let i = 0; i < 10000; i++) {
            let node = cc.instantiate(this.cocosPrefab);
            node.parent = this.node;
        }
        let endTime = new Date().getTime();
        cc.log('完成时间：' + endTime);
        cc.log('完成时长:' + (endTime - startTime) + '毫秒。');
        this.label.string = '完成时长:' + (endTime - startTime) + '毫秒。';
    }

    onCreateLabel() {
        let startTime = new Date().getTime();
        cc.log('开始时间：' + startTime);
        for (let i = 0; i < 10000; i++) {
            let node = cc.instantiate(this.labelPrefab);
            node.parent = this.node;
        }
        let endTime = new Date().getTime();
        cc.log('完成时间：' + endTime);
        cc.log('完成时长:' + (endTime - startTime) + '毫秒。');
        this.label.string = '完成时长:' + (endTime - startTime) + '毫秒。';
    }
}
